var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { FaTimes } from 'react-icons/fa';
import { formatDateForInput, convertValueTimeParameter } from '../common/utils.js';
var Filter = function (_a) {
    var parameters = _a.parameters, onApply = _a.onApply, onClose = _a.onClose, idDashboardItem = _a.idDashboardItem, initialFilters = _a.initialFilters, configuration = _a.configuration;
    var _b = React.useState({}), filterValues = _b[0], setFilterValues = _b[1];
    var _c = React.useState({}), errors = _c[0], setErrors = _c[1];
    var _d = React.useState([]), dropdownOptions = _d[0], setDropdownOptions = _d[1];
    React.useEffect(function () {
        if (initialFilters) {
            setFilterValues(initialFilters);
        }
    }, [initialFilters]);
    var validateField = function (parameter, value) {
        var _a;
        if (!value) {
            if ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) {
                return 'Trường này là bắt buộc';
            }
            return '';
        }
        var numValue = Number(value);
        if (parameter.data_type === 'integer' || parameter.data_type === 'double') {
            if (isNaN(numValue)) {
                return 'Giá trị không hợp lệ';
            }
            var validation = __assign({}, parameter.validation);
            if (validation.gte)
                if (validation.gte !== undefined && numValue < validation.gte) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i l\u1EDBn h\u01A1n ho\u1EB7c b\u1EB1ng ".concat(validation.gte);
                }
            if (validation.gt)
                if (validation.gt !== undefined && numValue <= validation.gt) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i l\u1EDBn h\u01A1n ".concat(validation.gt);
                }
            if (validation.lt)
                if (validation.lt !== undefined && numValue >= validation.lt) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i nh\u1ECF h\u01A1n ".concat(validation.lt);
                }
            if (validation.lte)
                if (validation.lte !== undefined && numValue > validation.lte) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i nh\u1ECF h\u01A1n ho\u1EB7c b\u1EB1ng ".concat(validation.lte);
                }
        }
        return '';
    };
    var hasEmptyRequiredFields = function () {
        return parameters.some(function (parameter) {
            var _a;
            return ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) &&
                (filterValues[parameter.code] === undefined ||
                    filterValues[parameter.code] === '' ||
                    filterValues[parameter.code] === null);
        });
    };
    var handleInputChange = function (code, value, dataType) {
        var _a, _b, _c, _d;
        var parsedValue = value;
        switch (dataType) {
            case 'integer':
                parsedValue = typeof value === 'string' ? parseInt(value) : value ? 1 : 0;
                break;
            case 'double':
                parsedValue = typeof value === 'string' ? parseFloat(value) : value ? 1 : 0;
                break;
            case 'boolean':
                parsedValue = Boolean(value);
                break;
            case 'datetime':
            case 'date':
                if (typeof value === 'string') {
                    var match = value.match(/^(\d{1,4})-(\d{2})-(\d{2})(T(\d{2}):(\d{2})(:(\d{2})(.(\d{1,3}))?)?)?$/);
                    if (match)
                        parsedValue = new Date(Number(match[1]), Number(match[2]) - 1, Number(match[3]), Number((_a = match[5]) !== null && _a !== void 0 ? _a : 0), Number((_b = match[6]) !== null && _b !== void 0 ? _b : 0), Number((_c = match[8]) !== null && _c !== void 0 ? _c : 0), Number((_d = match[10]) !== null && _d !== void 0 ? _d : 0)).toISOString();
                }
                break;
        }
        setFilterValues(function (prev) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[code] = parsedValue, _a)));
        });
        setErrors(function (prev) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[code] = '', _a)));
        });
    };
    var handleApply = function () {
        var newErrors = {};
        var hasErrors = false;
        parameters.forEach(function (parameter) {
            var error = validateField(parameter, filterValues[parameter.code]);
            if (error) {
                newErrors[parameter.code] = error;
                hasErrors = true;
            }
        });
        setErrors(newErrors);
        if (!hasErrors) {
            onApply(filterValues);
        }
    };
    var renderInput = function (parameter) {
        var value = parameter.code
            ? filterValues[parameter.code] !== undefined
                ? filterValues[parameter.code]
                : convertValueTimeParameter(parameter.default) || ''
            : '';
        var error = parameter.code ? errors[parameter.code] : '';
        var inputPropsClass = {
            className: "filter-input ".concat(error ? 'filter-input--error' : ''),
            'aria-invalid': !!error,
        };
        var renderField = function () {
            var getListParameterData = function () { return __awaiter(void 0, void 0, void 0, function () {
                var dataParam;
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!(configuration === null || configuration === void 0 ? void 0 : configuration.fnGetParameterDataAsync)) return [3, 2];
                            return [4, configuration.fnGetParameterDataAsync({
                                    id: idDashboardItem,
                                    parameter_code: (_a = parameter === null || parameter === void 0 ? void 0 : parameter.code) !== null && _a !== void 0 ? _a : '',
                                })];
                        case 1:
                            dataParam = _b.sent();
                            return [2, dataParam.data];
                        case 2: return [2, []];
                    }
                });
            }); };
            switch (parameter.input_type) {
                case 'number':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "number", value: Number(value), onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
                case 'checkbox':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "checkbox", checked: !!value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.checked, parameter.data_type);
                            } })) }));
                case 'date':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "date", value: formatDateForInput(value, 'date'), onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
                case 'datetime':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "datetime-local", value: formatDateForInput(value, 'datetime-local'), onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
                case 'dropdown':
                    React.useEffect(function () {
                        var fetchDropdownData = function () { return __awaiter(void 0, void 0, void 0, function () {
                            var data;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, getListParameterData()];
                                    case 1:
                                        data = _a.sent();
                                        if (data.length > 0) {
                                            setDropdownOptions(data.map(function (item) { return ({
                                                key: item.key,
                                                label: item.label || '',
                                            }); }));
                                        }
                                        else
                                            setDropdownOptions([]);
                                        return [2];
                                }
                            });
                        }); };
                        fetchDropdownData();
                    }, [parameter.code]);
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsxs("select", __assign({}, inputPropsClass, { value: value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            }, children: [_jsxs("option", { value: "", children: ["Ch\u1ECDn ", parameter.label] }), dropdownOptions.map(function (option) { return (_jsx("option", { value: option.key, children: option.label || option.key }, option.key)); })] })) }));
                default:
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "text", value: value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
            }
        };
        return (_jsxs("div", { className: "filter-input-item", children: [renderField(), error && _jsx("p", { className: "filter-error", children: error })] }));
    };
    return (_jsx("div", { className: "filter-overlay", children: _jsxs("div", { className: "filter-modal", children: [_jsxs("div", { className: "filter-modal__header", style: { display: 'flex', justifyContent: 'space-between', alignItems: 'center' }, children: [_jsx("p", { className: "filter-modal__header--text", children: "L\u1ECDc d\u1EEF li\u1EC7u" }), _jsx("button", { className: "filter-modal__header--btn-close", disabled: hasEmptyRequiredFields(), onClick: onClose, children: _jsx(FaTimes, { size: 30, style: { display: 'block' } }) })] }), _jsx("div", { className: "filter-content", children: (parameters === null || parameters === void 0 ? void 0 : parameters.length) > 0 &&
                        parameters.map(function (parameter) {
                            var _a;
                            return (_jsxs("div", { className: "filter-item", children: [_jsxs("label", { children: [parameter.label || parameter.code, ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) && _jsx("span", { className: "required", children: "*" })] }), renderInput(parameter)] }, parameter.code));
                        }) }), _jsx("div", { className: "filter-actions", children: _jsx("button", { className: "btn btn__primary filter-actions__accept", onClick: handleApply, children: "L\u1ECDc d\u1EEF li\u1EC7u" }) })] }) }));
};
export default Filter;
