export type SDashboardItemSetup_Chart_X_axis = {
    field?: string | null;
    min?: number | null;
    max?: number | null;
    axisLabel?: SDashboardItemSetup_Chart_X_axis_AxisLabel | null;
    splitLine?: SDashboardItemSetup_Chart_X_axis_SplitLine | null;
};
export type SDashboardItemSetup_Chart_X_axis_SplitLine = {
    lineStyle?: SDashboardItemSetup_Chart_X_axis_SplitLine_LineStyle | null;
};
export type SDashboardItemSetup_Chart_X_axis_SplitLine_LineStyle = {
    color?: string | null;
    type?: string | null;
    width?: number | null;
};
export type SDashboardItemSetup_Chart_X_axis_AxisLabel = {
    rotate?: number | null;
};
export type SDashboardItemSetup_Chart_Y_axis = {
    field?: string | null;
    min?: number | null;
    max?: number | null;
    axisLabel?: SDashboardItemSetup_Chart_Y_axis_AxisLabel | null;
    splitLine?: SDashboardItemSetup_Chart_Y_axis_SplitLine | null;
};
export type SDashboardItemSetup_Chart_Y_axis_AxisLabel = {
    rotate?: number | null;
};
export type SDashboardItemSetup_Chart_Y_axis_SplitLine = {
    lineStyle?: SDashboardItemSetup_Chart_Y_axis_SplitLine_LineStyle | null;
};
export type SDashboardItemSetup_Chart_Y_axis_SplitLine_LineStyle = {
    color?: string | null;
    type?: string | null;
    width?: number | null;
};
export type SDashboardItemSetup_Chart_Seri = {
    field?: string | null;
};
export type SDashboardItemSetup_Chart_Item_styles = {
    condition?: SDashboardItemSetup_Chart_Item_styles_Condition | null;
    style?: SDashboardItemSetup_Chart_Item_styles_Style | null;
};
export type SDashboardItemSetup_Chart_Item_styles_Condition = {
    index?: number | null;
    name?: string | null;
    regex?: string | null;
    gt?: number | null;
    gte?: number | null;
    lt?: number | null;
    lte?: number | null;
};
export type SDashboardItemSetup_Chart_Item_styles_Style = {
    bg_color?: string | null;
    bg_to_color?: string | null;
    line_color?: string | null;
    border_radius?: Array<number | null | undefined> | null;
    smooth?: boolean | null;
    radar_max?: number | null;
};
export type SDashboardItemSetup_Chart_Legend_Align = {
    horizontal?: string | null;
    vertical?: string | null;
};
export type SDashboardItemSetup_Chart_Legend = {
    show?: boolean | null;
    orient?: string | null;
    align?: string | null;
    left?: string | null;
    top?: string | null;
    right?: string | null;
    bottom?: string | null;
};
export type SDashboardItemSetup_Chart_Tooltip_TextStyle = {
    fontSize?: number | null;
    color?: string | null;
};
export type SDashboardItemSetup_Chart_Title_TextStyle = {
    fontSize?: number | null;
    color?: string | null;
};
export type SDashboardItemSetup_Chart_Tooltip = {
    show?: boolean | null;
    trigger?: string | undefined;
    backgroundColor?: string | null;
    borderRadius?: number | null;
    textStyle?: SDashboardItemSetup_Chart_Tooltip_TextStyle | null;
};
export type SDashboardItemSetup_Chart_Title = {
    show?: boolean | null;
    text?: string | null;
    textStyle?: SDashboardItemSetup_Chart_Title_TextStyle | null;
};
export type SDashboardItemSetup_Chart = {
    title?: SDashboardItemSetup_Chart_Title | null;
    legend?: SDashboardItemSetup_Chart_Legend | null;
    tooltip?: SDashboardItemSetup_Chart_Tooltip | null;
    x_axis?: SDashboardItemSetup_Chart_X_axis | null;
    y_axis?: SDashboardItemSetup_Chart_Y_axis | null;
    seri?: SDashboardItemSetup_Chart_Seri | null;
    item_styles?: Array<SDashboardItemSetup_Chart_Item_styles | null | undefined> | null;
    chart_link?: string | null;
};
export type SDashboardItemSetup_Table = {
    page_size?: number | null;
    page_sizes?: Array<number | null | undefined> | null;
    columns?: Array<SDashboardItemSetup_Table_Columns | null | undefined> | null;
    excel_columns?: Array<SDashboardItemSetup_Table_Excel_columns | null | undefined> | null;
};
export type SDashboardItemSetup_Table_Columns = {
    field?: string | null;
    header_text?: string | null;
    format_string?: string | null;
    width?: number | null;
    styles?: SDashboardItemSetup_Table_Columns_Styles | null;
};
export type SDashboardItemSetup_Table_Columns_Styles = {
    text_align?: string | null;
    bold?: boolean | null;
    italic?: boolean | null;
    text_color?: string | null;
    bg_color?: string | null;
    custom_class?: string | null;
};
export type SDashboardItemSetup_Table_Excel_columns = {
    field?: string | null;
    header_text?: string | null;
    format_string?: string | null;
    width?: number | null;
    styles?: SDashboardItemSetup_Table_Excel_columns_Styles | null;
};
export type SDashboardItemSetup_Table_Excel_columns_Styles = {
    text_align?: string | null;
    bold?: boolean | null;
    italic?: boolean | null;
    text_color?: string | null;
    bg_color?: string | null;
};
export type SDashboardItemSetup_Datasource = {
    main?: string | null;
    sub?: string | null;
    parameters?: Array<SDashboardItemSetup_Datasource_Parameters | null | undefined> | null;
};
export type SDashboardItemSetup_Datasource_Parameters = {
    code?: string | null;
    query?: string | null;
};
export type SDashboardItemSetup_Parameters = {
    code?: string | null;
    data_type?: string | null;
    is_array?: boolean | null;
    default?: string | null;
    label?: string | null;
    input_type?: string | null;
    validation?: SDashboardItemSetup_Parameters_Validation | null;
};
export type SDashboardItemSetup_Parameters_Validation = {
    required?: boolean | null;
    gt?: number | null;
    gte?: number | null;
    lt?: number | null;
    lte?: number | null;
    pattern?: string | null;
    formula?: string | null;
};
export type SDashboardItemSetup_type = 'vertical-bar-chart' | 'horizontal-bar-chart' | 'line-chart' | 'pie-chart' | 'stack-area-chart' | 'stack-bar-chart' | 'step-line-chart' | 'percent-chart' | 'table' | 'tree';
export type SDashboardItemSetup = {
    id: string;
    type: SDashboardItemSetup_type | string;
    title?: string;
    tags?: Array<string> | null;
    x: number;
    y: number;
    width: number;
    height: number;
    chart?: SDashboardItemSetup_Chart | null;
    table?: SDashboardItemSetup_Table | null;
    parameters?: Array<SDashboardItemSetup_Parameters | null | undefined> | null;
};
export type SDashboardItemSetting = {
    setup: SDashboardItemSetup;
};
export type GetChartDataParametersResult = {
    data: Array<Record<string, any | null | undefined> | null | undefined>;
    sub?: Array<Record<string, any | null | undefined> | null | undefined> | null;
};
export type GetParameterDataParametersResultItem = {
    key: string | null;
    label?: string | null;
};
export type GetParameterDataParametersResult = {
    data: Array<GetParameterDataParametersResultItem>;
};
export type SDashboardItemConfiguration = SDashboardItemSetting & {
    fnGetChartDataAsync: (arg: GetChartDataParameters) => Promise<GetChartDataParametersResult>;
    emptyComponentChartItem?: React.JSX.Element;
    loadingComponentChartItem?: React.JSX.Element;
    errorComponentChartItem?: React.JSX.Element;
};
export type GetItemsParameters = {
    dashboardCode: string;
    limit?: number;
    offset?: number;
};
export interface GetChartDataParameters {
    id: string;
    limit?: number;
    offset?: number;
    filter?: Record<string, string | null | undefined> | null;
}
export interface GetParameterDataParameters {
    id: string;
    parameter_code: string;
    filter?: Record<string, string | null | undefined> | null;
}
export type SubChartItemComponentFunctionArgument = {
    subData?: Array<Record<string, string | number>> | null;
    setup: SDashboardItemSetup;
};
export type SubChartItemComponentFunctionLinkArgument = {
    setup: SDashboardItemSetup;
    chart_link?: string;
    filter?: Record<string, string | number | null | undefined> | null;
};
export type SubChartItemComponentFunctionHistoryArgument = {
    filter?: Record<string, string | number | null | undefined> | null;
};
export type SubChartItemComponentFunction = (arg: SubChartItemComponentFunctionArgument) => React.JSX.Element;
export type SDashboardConfiguration = {
    fnGetItemsAsync: (arg: GetItemsParameters) => Promise<Array<SDashboardItemSetting>>;
    fnGetChartDataAsync: (arg: GetChartDataParameters) => Promise<GetChartDataParametersResult>;
    fnGetSubComponentChartItem?: SubChartItemComponentFunction;
    fnHandleDashboardLink?: (arg: SubChartItemComponentFunctionLinkArgument) => void | Promise<void>;
    fnGetParameterDataAsync?: (arg: GetParameterDataParameters) => Promise<GetParameterDataParametersResult>;
    filterDashboard?: (arg: SubChartItemComponentFunctionHistoryArgument) => object;
    loadingComponentChartItem?: React.JSX.Element;
    errorComponentChartItem?: React.JSX.Element;
    emptyComponentChartItem?: React.JSX.Element;
};
export type SDashboardProps = {
    dashboardCode: string;
    enabled: boolean;
    title?: string;
    grid_column?: number;
    gap?: string | number;
    background?: string;
    loadingSDashboard?: React.JSX.Element;
    emptySDashboard?: React.JSX.Element;
    errorSDashboard?: React.JSX.Element;
    configuration: SDashboardConfiguration;
};
export type SDashboardItemProps = {
    setup: SDashboardItemSetup;
    chartData?: Array<Record<string, number | string>>;
};
export type TableDashboardItemProps = SDashboardItemProps & {
    onPageChange?: (page: number) => void;
    onPageSizeChange?: (pageSize: number) => void;
};
